/*
    diplom - creates xml's with diploma specifications
    Copyright (C) 2009 Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 2 as published by the Free Software Foundation.

*/

#include <ctype.h>
#include <stdio.h>
#include <string.h>

#include "main.h"
#include "diplom.h"


char *diplompath = NULL;
char *diplomtmpl = "vzor.xml";
int diplomplace = 10;

int make_diplom(int categ, char *acall, int place, char *aband_str){
	FILE *f, *g;
	char s[1024], raw[100], *c, key[1024], call[100], band_str[100];
	int a, i;


	if (!diplompath || !*diplompath) return 0;
	if (!diplomtmpl || !*diplomtmpl) return 0;

	f = fopen(diplomtmpl, "rt");
	if (!f) {
		eprintf("Can't read %s\n", diplomtmpl);
		return -1;
	}
	
    safe_strncpy0(call, acall, sizeof(call));
    for (c=call; *c!='\0'; c++) *c=toupper(*c);
	get_raw_call(raw, call);

    safe_strncpy0(band_str, aband_str, sizeof(band_str));
    space2underscore(band_str);

    sprintf(s, "%s/%s_%s_%02d_%s.xml", diplompath, band_str, categs[categ].name, place, raw);
    //printf("  file='%s'  \n", s);
	g = fopen(s, "wt");
	if (!g) {
		fclose(f);
		eprintf("Can't write %s\n", s);
		return -2;
	}

	while ((a=fgetc(f))!=EOF){
        if (a=='@'){
            i=0;
            while((a=fgetc(f))!=EOF){
                if (i==1000) break;
                if (a=='@') break;
                key[i++]=a;
            }
            key[i]='\0';
            if (!stricmp(key, "CALL")){
                fprintf(g, "%s", call);

            }else if (!stricmp(key, "PLACE")){
                fprintf(g, "%d", place);

            }else if (!stricmp(key, "CTEST")){
                fprintf(g, "%s", ctest_name);

            }else if (!stricmp(key, "BAND")){
                fprintf(g, "%s", aband_str);

            }else if (!stricmp(key, "CATEG")){
                fprintf(g, "%s", categs[categ].name);

            }else if (!stricmp(key, "VYSTUP")){
                fprintf(g, "%s/%s_%s_%02d_%s.jpg", diplompath, band_str, categs[categ].name, place, raw);

            }else{
                fprintf(g, "@%s@", key);
                eprintf("%s: Unknown key %s\n", diplomtmpl, key);
            }
            continue; // skip fputs
        }
		fputc(a, g);
	}

	fclose(f);
	fclose(g);
	return 0;
}

char *get_raw_call(char *buf, char *call){
    char s[20], *c;
    char *token_ptr;

    safe_strncpy0(s,call,20);
   
    for (c=strtok_r(s, "/", &token_ptr); c!=NULL; c=strtok_r(NULL, "/", &token_ptr)){ 
        if (strlen(c)<3) continue;
        if (strlen(c)==3 && c[2]>='0' && c[2]<='9') continue;
          /*  3rd char cannot be number , OK1 vs G8M */
        safe_strncpy0(buf, c, 20);  
        return buf;
    }
    safe_strncpy0(buf, call, 20);  
    return buf;
}

char *space2underscore(char *str){
    char *c;

    for (c=str; *c!='\0'; c++){
        if (*c==' ') *c='_';
    }
    return str;
}
